//Top Note


2 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

MidiIn min;
MidiMsg msg;

// try to open MIDI port (see chuck --probe for available devices)
if( !min.open( device ) ) me.exit();

// print out device that was opened
<<< "MIDI device:", min.num(), " -> ", min.name() >>>;


// make our own event
class NoteEvent extends Event
{
    int note;
    int velocity;
}

// the event
NoteEvent on;
// array of ugen's handling each note
Event @ us[128];

// the base patch
Gain g => JCRev r => dac;
.3 => g.gain;
.2 => r.mix;

// handler for a single voice
fun void handler()
{
    // don't connect to dac until we need it
    Mandolin voc => JCRev j => Echo a;
    220.0 => voc.freq;
0.95 => voc.gain;
.8 => j.gain;
.1 => j.mix;
1000::ms => a.max;
750::ms => a.delay;
.50 => a.mix;

    Event off;
    int note;
    
    while( true )
    {
        on => now;
        if (on.velocity <126) {
        on.note + 10 => note;
        voc => g;
        
        // dynamically repatch
        
        
        Std.mtof (note) =>voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 1 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note - 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note - 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 1 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 5 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        220::ms => now;
        note + 1  => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
                
        off => now;
        null @=> us[note];
        voc =< g;

    } else {
           on.note + 22 => note;
        voc => g;
        
        // dynamically repatch
        
        
        Std.mtof (note) =>voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        450::ms => now;
        note - 3 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        450::ms => now;
        note -3 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        450::ms => now;
        note - 3 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
        450::ms => now;
        note - 1 => note;
        Std.mtof( note ) => voc.freq;
        Std.rand2f( .6, .8 ) => voc.pluckPos;
        on.velocity / 128.0 => voc.pluck;
        off @=> us[note];
                off => now;
        null @=> us[note];
        voc =< g;
    }
}
}

// spork handlers, one for each voice

for( 0 => int i; i < 20; i++ ) {
    spork ~ handler();
    }

 
// infinite time-loop
while( true )
{
    // wait on midi event
    min => now;
    
    // get the midimsg
    while( min.recv( msg ) )
    {
        // catch only noteon
        if( msg.data1 != 144 )
            continue;
        
        // check velocity
        if( msg.data3 > 0 )
        {
            // store midi note number
            msg.data2 => on.note;
            // store velocity
            msg.data3 => on.velocity;
            // signal the event
            on.signal();
            // yield without advancing time to allow shred to run
            me.yield();
        }
        else
        {
            if( us[msg.data2] != null ) us[msg.data2].signal();
        }
    }
}

